<?php
if (!defined('MEDIAWIKI')) die("MediaWiki extensions cannot be run directly.");
if (!defined('WikiDB')) {
	die("The WikiDB extension has not been set up correctly.<br>'"
		. basename(__FILE__) . "' should not be included directly.<br>Instead, "
		. "add the following to LocalSettings.php: "
		. "<tt><b>include_once(\"WikiDB/WikiDB.php\");</b></tt>");
}
/**
 * Some regular expressions used within the WikiDB code.
 *
 * @package MediaWiki
 * @subpackage Extensions
 *
 * @author Mark Clements <mclements at kennel17 dot co dot uk>
 * @copyright Copyright  2006-2013, Mark Clements
 * @license http://creativecommons.org/licenses/by-sa/2.5/ cc-by-sa 2.5 or later
 * @version $Rev: 792 $
 */

WikiDB_RegisterRevision('$Rev: 792 $');

////////////////////////////////////
// Regex to match a DB field definition (single line) in a table page.
// [0] - Whole line
// [1] - Field name
// [2] - Field type
// [3] - Arguments (comma-separated list)
// [4] - Link (if it starts with # it's an alias) - square brackets not included.
// [5] - Comment, including starting dashes (rest of line)
	$pRegexDBLine =	'/^						# Anchor to start of line
					>						# All field lines start with ">"
					\s*						# Optional whitespace
					([^:[-]+)				# Field name (cannot contain ":",
											# "[" or "-")
					(?:\:\s*				# If colon is present then field type
											# is defined.
					  ([^\s[\(-]*)			# Optional :FieldType (cannot contain
											# spaces, "(", "[" or "-")
					  \s*(?:(?U)\((.*)\))?	# Optional field type arguments within
											# parentheses
					)?						# End of optional field type
					\s*						# Optional whitespace
					(?:(?U)\[\[(.*)\]\])?	# Optional link [[anything]]
					\s*						# Optional whitespace
					(?:--(.*))?				# Optional comment ("--" to end of line)
					$/x';					// x = allows these comments.

////////////////////////////////////
// Regex to match a <data> tag:
// [0] - Whole tag
// [1] - attribute portion of opening tag ('<data a="vala" b="valb">' becomes
// 		 'a="vala" b="valb"')
// [2] - Contents of the tag (between <data ...> and </data>
// Tag may be unterminated, in which case this captures the whole rest of the page.
	$pRegexDataTag = '/<\s*data\s+(.*)>(.*)(?:<\s*\/data\s*>|$)/sDiU';

////////////////////////////////////
// Regex to match quoted attribute/value pairs (e.g. within an html opening tag):
// [0] - matched string
// [1] - attribute name
// [2] - value without quotes
	$pRegexAttributeValuePairs = '/(.*)="(.*)"/sU';

////////////////////////////////////
// Regex to match all unwanted link characters.  Used to remove them from the Alias
// string.  It matches 3 characters: [, ] and #
	$pRegexUnwantedLinkChars = '/\[|\]|#/';


